/* GCC */
#include<fstream>
using namespace std;

const int numstart = 48;

int toint(char n){
    return ((int)n - numstart);
}

char tochar(int n){
    return ((char)(n + numstart));
}

string rzeroes(string n){
    while(n[0] == '0'){
        string newn = "";
        for(int i = 1; i < n.size(); ++i)
            newn += n[i];
        n = newn;
    }
    return n;
}

string divide(string n, int d){
    int o = 0;
    string dnum = "";
    for(int i = 0; i < n.size(); ++i){
        int num = 10*o + toint(n[i]);
        o = num % d;
        dnum += tochar(num/d);
    }
    if(o)
        return "-1";
    return rzeroes(dnum);
}

int main(){
    ifstream in;
    ofstream out;
    in.open("divisors.in");
    out.open("divisors.out");

    string n;
    in>>n;

    int a1 = 0,
        a2 = 0,
        a3 = 0,
        a4 = 0;

    for(;divide(n,2)!="-1"; ++a1, n = divide(n,2)){}
    for(;divide(n,3)!="-1"; ++a2, n = divide(n,3)){}
    for(;divide(n,5)!="-1"; ++a3, n = divide(n,5)){}
    for(;divide(n,7)!="-1"; ++a4, n = divide(n,7)){}

    int divisors = (a1 + 1)*(a2 + 1)*(a3 + 1)*(a4 + 1);
    out<<divisors;

    out.close();
    in.close();
}

