/* GCC */
#include<iostream>
#include<cmath>
#include<fstream>
#include<vector>
using namespace std;
long long maxPow2(vector<int> &a, int tmp)
{
    vector<int> b = a;
    long long rez = 1;
    while(a.size() > 0)
    {
        int carry = 0;
        for(int i = b.size()-1; i >= 0; i --)
        {
            int cur = b[i] + carry*10;
            if(i == 0 && (cur % tmp != 0)) return rez;
            b[i] = cur/tmp;
            carry = cur % tmp;
        }
        while(b.back() == 0) b.pop_back();
        a = b;
        rez ++;
    }
    return rez;
}
int main()
{
    ifstream fin("divisors.in");
    ofstream fout("divisors.out");

    long long rez;
    string n;
    fin >> n;

    vector<int> a;
    for(int i = n.size()-1; i >= 0; i --)
        a.push_back(n[i]-'0');

    long long mas[4];
    mas[0] = maxPow2(a,2);
    mas[1] = maxPow2(a,3);
    mas[2] = maxPow2(a,5);
    mas[3] = maxPow2(a,7);

    //for(int i = 0; i < 4; i ++) cout << mas[i] << " ";
    //cout << "\n";
    rez = (mas[0]*mas[1]*mas[2]*mas[3]);
    fout << rez << "\n";
    return 0;
}

