/* GCC */
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

int main()
{
    ifstream fin;
    fin.open("decomp.in");
    int n;
    fin >> n;

    vector<int> x(n);
    vector<int> x_2(n * 3);

    for(int i = 0; i < n; i++) {
        fin >> x[i];
        x_2[i] = x[i];
        x_2[i + n] = x[i];
        x_2[i + n * 2] = x[i];
    }

    fin.close();

    int k = 0;

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < n; j++) {
            int x1 = x_2[i];
            int x2 = x_2[i + x[j]];
            if(x_2[i] == x_2[i + x[j]] && x[j] != -1) {
                x[j] = -1;
                k++;
                break;
            }
        }
    }

    ofstream fout;
    fout.open("decomp.out");

    fout << -1;

    fout.close();
    return 0;
}
