/* GCC */
#include <iostream>
#include <fstream>
#include <map>
#include <set>
#include <vector>
#define ll long long unsigned int


using namespace std;

ll n;
map<ll,ll> arr;
vector<int> vrr;
bool paint(int color,int beg)
{
    int i=beg;
    while (arr[i]==0)
    {
        arr[i]=color;
        i=(vrr[i]+i)%(2*n);
    }
    return (arr[i]==color);
}

void input()
{
    int l;
    ios::sync_with_stdio(0);
    ifstream cin("decomp.in");
    cin>>n;
    for(int i=0;i<n;i++)
    {
        arr[i]=0;
        int a;
        cin>>a;
        vrr.push_back(a);
    }
    for(int i=0;i<n;i++)
    {
        arr[i+n]=0;
        vrr.push_back(vrr[i]);
    }
}

void output()
{

    for(int i=0;i<2*n;i++)
    {
        cout<<arr[i]<<' ';
    }
    cout<<endl;
}

int main()
{
    ofstream cout("decomp.out");
    vrr.clear();
    arr.clear();
    input();
    int k=1;
    for(int i=0;i<vrr.size();i++)
    {
        if(!arr[i])
        {
            if(!paint(k,i))
            {
                cout<<-1<<endl;
                return 0;
            }
            //output();
            k++;
        }
    }
    if(k)
        cout<<k-1<<endl;
    else
        cout<<-1<<endl;
    return 0;
}
/*
#include <iostream>
#include <fstream>
#include <map>
#include <set>
#include <vector>
#define ll long long unsigned int


using namespace std;

ll n,MAXE;
map<ll,ll> arr;
vector<int> vrr;
vector<vector<int> > vvr;


void output()
{
    for(int i=0;i<MAXE;i++)
    {
        cout<<arr[i]<<' ';
    }
    cout<<endl<<MAXE<<endl;
}


bool recount()
{
    for(int i=0;i<vvr.size();i++)
    {
        for(int j=vvr[i].size();j<=MAXE;j++)
        {
            vvr[i][j]=vvr[i][j-vvr[i].size()];
            if(arr[vvr[i][j]]==0)
                arr[vvr[i][j]]=i+1;
            else
                return false;
        }
    }
    return true;
}


bool paint(int color,int beg)
{
    vector<int> vr;
    int i=beg;
    while ((i%n!=0&&arr[i%n]==0)||(i%n==0&&arr[n]==0))
    {
        arr[i]=color;
        i=(vrr[i%n]+i);
        vr.push_back(i);
    }
    if((i%n!=0&&arr[i%n]==color)||(i%n==0&&arr[n]==color))
        arr[i]=color;
    if(vr.back()>MAXE)
    {
        if((vr.back())%n==0)
            MAXE=vr.back();
        else
            MAXE=vr.back()-vr.back()%n+n;
        if(!recount())
            return false;
    }
    vvr.push_back(vr);
    output();
    return (arr[i]==color||arr[i]==0);
}

void input()
{
    int l;
    ios::sync_with_stdio(0);
    ifstream cin("in.in");
    cin>>n;
    vrr.push_back(0);
    for(int i=1;i<=n;i++)
    {
        arr[i]=0;
        int a;
        cin>>a;
        vrr.push_back(a);
    }
}

int main()
{
    vrr.clear();
    arr.clear();
    input();
    MAXE=n;
    int k=1;
    for(int i=1;i<=MAXE;i++)
    {
        if(!arr[i])
        {
            if(!paint(k,i))
            {
                cout<<-1<<endl;
                return 0;
            }
            output();
            k++;
        }
    }
    if(k)
        cout<<k-1<<endl;
    else
        cout<<-1<<endl;
    return 0;
}
*/
