/* GCC */
#include <fstream>
#include <iostream>
#include <vector>

using namespace std;

vector<int> indexesUniques;

bool IsOnArray(vector<int> arr, int index)
{
    int i = 0;
    for(int i = 0;i < arr.size();i++)
        if(arr[i] == index)
            return true;
    return false;
}


bool Minus()
{
    vector<int> un;
    for(int i = 0;i < indexesUniques.size();i++)
        if(IsOnArray(un, indexesUniques[i]))
            return false;
    return true;
}

vector<int> GenerateC(vector<int> arr, int index)
{
    vector<int> indexs;
    indexs.push_back(index);
    for(int i = 0;i < 20;i++)
    {
        indexs.push_back(arr[indexs[i] % arr.size()] + indexs[i]);
        indexesUniques.push_back(arr[indexs[i] % arr.size()] + indexs[i]);
    }
    return indexs;
}


bool IsOnArrays(vector<vector<int> > arr, int index)
{
    for(int i = 0;i < arr.size();i++)
        if(IsOnArray(arr[i], index))
            return true;
    return false;
}

int GetFirstEmpty(vector<vector<int> > arr)
{
    int i = 0;
    while(i < 20)
    {
        //cout << i << endl;
        if(!IsOnArrays(arr, i))
            break;
        i++;
    }
    return i;
}

int main()
{
    ifstream in;
    in.open("decomp.in");
    ofstream out;
    out.open("decomp.out");
    int n;
    in >> n;
    vector<int> arr;
    vector<vector<int> > arrays;
    arr.resize(n);
    for(int i = 0;i < n;i++)
        in >> arr[i];
    for(int i = 0;GetFirstEmpty(arrays) != 20;i++)
        arrays.push_back(GenerateC(arr, GetFirstEmpty(arrays)));
    /*for(int i = 0;i < arrays.size();i++)
    {
        for(int j = 0;j < arrays[i].size();j++)
            cout << arrays[i][j] << ' ';
        cout << endl;
    }*/
    if(!Minus())
        out << -1;
    else
        out << arrays.size();
    //out << -1;
    in.close();
    out.close();
    return 0;
}
