/* GCC */
#include <iostream>
#include <string>
#include <fstream>

using namespace std;
const int primes[4] = {2, 3, 5, 7};

bool divide(string& num, int d)
{
    string new_num;
    new_num.reserve(num.size());
    int carry(0), cur, fd;
    for(int i = 0; i < num.size(); ++i)
    {
        cur = (carry * 10 + num[i]);
        new_num.push_back(fd = cur / d);
        carry = cur - fd * d;
    }
    if(carry)
        return false;
    num.swap(new_num);
    return true;
}

int main(void)
{
    ios_base::sync_with_stdio(false);
    string num;
    ifstream in("divisors.in");
    in >> num;
    for(int i = 0; i < num.size(); ++i)
        num[i] -= '0';
    in.close();
    int pr_cnt[4] = {}, ans(1);
    for(int pr_idx = 0; pr_idx < 4; ++pr_idx)
    {
        while(divide(num, primes[pr_idx]))
            ++pr_cnt[pr_idx];
        ans *= (pr_cnt[pr_idx] + 1);
    }
    ofstream out("divisors.out");
    out << ans << '\n';
    out.close();
    return 0;
}
