/* GCC */
#include<iostream>
#include<queue>
#include<cmath>
#include<fstream>
using namespace std;
int a[12][12] = {0};
int cost[63][12];

struct cave
{
    int num,day;
    unsigned long long sum;
    cave(int num,int day, unsigned long long sum) : num(num),day(day), sum(sum) {}
};

queue<cave> Q;
int main()
{
    ifstream fin("caves.in");
    ofstream fout("caves.out");
    int Nw = 0;
    unsigned long long pmax = 0,pmin = pow(2,63);
    int m,l;
    fin >> m >> l;
    unsigned long long cisla[l+2];

    for(int i = 1; i <= 10; i ++) //  
        for(int j = 1; j <= 10; j ++) fin >> a[i][j];

    for(int i = 1; i <= m; i ++) //   
        for(int j = 1; j <= 10; j ++) fin >> cost[i][j];

    for(int i = 1; i <= l; i ++) fin >> cisla[i];

    for(int i = 1; i <= 10; i ++) Q.push(cave(i,1,cost[1][i]));

    while(!Q.empty())
    {
        cave u = Q.front();
        //cout << u.num << " " << u.day << " " << u.sum << "\n";
        Q.pop();
        if(u.day == m)
        {
            bool op = true;
            for(int i = 1; i <= l && op; i ++)
            {
                if(u.sum == cisla[i]) op = false;
                else if(u.sum > cisla[i]) break;
            }
            if(op)
            {
                Nw ++;
                pmax = max(u.sum,pmax);
                pmin = min(u.sum,pmin);
            }
        }
        else
        {
            for(int i = 1; i <= 10; i ++)
            {
                if(a[u.num][i] == 1) Q.push(cave(i,u.day+1,u.sum+cost[u.day+1][i]));
            }
        }
    }

    if(Nw == 0) pmax = pmin = 0;
    fout << Nw << " " << pmax << " " << pmin << "\n";
    return 0;
}
